/* @(#)system.c	4.1 (Berkeley) 12/21/80 */

#if defined(__STDC__) || defined(__cplusplus)
#define STDC	1
#define ARGS(s) s
#else
#define STDC	0
#define ARGS(s) ()
#define const
#endif

#include <signal.h>
#include <string.h>
#include <stdio.h>			/* for perror() prototype */

#if !defined(__NeXT__)
#include <unistd.h>			/* for read() et al prototypes */
#endif

#include <sys/wait.h>			/* for wait() prototype */
#if defined(__NeXT__)
#define wait_arg_t	union wait
#else
#define wait_arg_t	int
#endif

#ifndef NULL
#  define NULL 0
#endif /* NULL */

#include <errno.h>

int	cshsystem ARGS((char *s));

int
cshsystem(s)
char *s;
{
	int pid, w;
	wait_arg_t status;
#if defined(__NeXT__)
#define Status status.w_status
#else
#define Status status
#endif

#if 0
	char *getshell();	/* figure out users shell */
#endif
	char *shell;
	char *tail;

	shell = "/bin/csh";
	/** shell = getshell(); **/
	tail = strrchr(shell, '/');
	if (tail != (char *)NULL) {
		tail++;
	}

	if ((pid = fork()) == 0) {
		execl("/bin/csh", "csh", "-c", s, 0);
		/**execl(shell, (tail == NULL) ? shell : tail, "-c", s, 0);*/
		perror("cshsystem -- execl failed");
		_exit(errno);
	}

	if (pid == -1) {
		perror("cshsystem -- fork failed");
		_exit(errno);
	}

#if defined(HAVE_TERMIOS_H)
	signal(SIGINT, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	while ((w = (int)wait(&status)) != pid && w != -1)
		;
	if (w == -1)
		Status = -1;
	signal(SIGINT, SIG_DFL);
	signal(SIGQUIT, SIG_DFL);
#else /* NOT defined(HAVE_TERMIOS_H) */
	{
		register void (*istat)(), (*qstat)();
		istat = signal(SIGINT, SIG_IGN);
		qstat = signal(SIGQUIT, SIG_IGN);
		while ((w = (int)wait(&status)) != pid && w != -1)
				;

		if (w == -1)
				Status = -1;
		signal(SIGINT, istat);
		signal(SIGQUIT, qstat);
	}
#endif /* defined(HAVE_TERMIOS_H) */

	return(Status);
}
